﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Chapter_09
{
    public class Customer : Contact
    {
        public string Gender { get; set; }
        public decimal Income { get; set; }
        internal CustomerStats Stats { get; set; }

        public override string Email
        {
            get
            {
                // wykonanie wyspecjalizowanej logiki
                return base.Email;
            }
            set
            {
                // wykonanie wyspecjalizowanej logiki
                base.Email = value;
            }
        }
        private string m_firstName = string.Empty;

        public string FirstName
        {
            get { return m_firstName; }
            set
            {
                if (!string.IsNullOrEmpty(value))
                {
                    m_firstName = value;
                }
            }
        }

        public string GenerateReport()
        {
            string fullAddress = base.FullAddress();
            // tu można wykonać inne działania...
            return fullAddress;
        }

        private string GetReportHeader()
        {
            return "Nagłówek raportu";
        }

        public bool IsContentAppropriate(WebSite site)
        {
            return Age > 18;
        }

        public override void SendAlert()
        {
            Console.WriteLine("Powiadomienie dla klasy Customer");
        }

        //public new void SendAlert()
        //{
        //    Console.WriteLine("Powiadomienie dla klasy Customer");
        //}

        public override bool Equals(object obj)
        {
            Customer cust = obj as Customer;

            if (cust == null) return false;

            return cust.Name == Name;
        }

        public override int GetHashCode()
        {
            return Name.GetHashCode();
        }

        public override string ToString()
        {
            return Name;
        }
    }
}
